//+------------------------------------------------------------------+
//|                                                    HiLoTrend.mq4 |
//|                                Copyright  2008,   |
//+------------------------------------------------------------------+
#property indicator_chart_window

#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 LimeGreen
#property indicator_color3 Red
#property indicator_color4 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

extern int TP=85;
extern int SL=20;

//---- buffers
double Buy[];
double Sell[];
double Buy1[];
double Sell1[];
int init()	
{  
//---- indicator line
	SetIndexBuffer(0,Buy); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0, 108);
	SetIndexBuffer(1,Buy1); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1, SYMBOL_STOPSIGN);
	SetIndexBuffer(2,Sell); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2, 108); 
	SetIndexBuffer(3,Sell1); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3, SYMBOL_STOPSIGN); 
	return(0);  
}
int deinit()	
{	
	ObjectsDeleteAll(EMPTY, OBJ_TREND);
	return(0);  
}
//------------------------------------------------------------------ Right
int Right(int i, int mode)
{
	for (int j=i; j>=0; j--)
		if (mode==OP_BUY)
		{
			if (Low[j]<=Open[i]-SL*Point)	return (-1);
			if (High[j]>=Open[i]+TP*Point) return (j);
		}
		else if (mode==OP_SELL)
		{
			if (High[j]>=Open[i]+SL*Point) return (-1);
			if (Low[j]<=Open[i]-TP*Point) return (j);
		}
	return (-1);
}
//------------------------------------------------------------------ Left
int Left(int i, int mode)
{
	for (int j=i; j<Bars; j++)
		if (mode==OP_BUY)
		{
			if (Low[j]<=Open[i]-SL*Point)	return (-1);
			if (High[j]>=Open[i]+TP*Point) return (j);
		}
		else if (mode==OP_SELL)
		{
			if (High[j]>=Open[i]+SL*Point) return (-1);
			if (Low[j]<=Open[i]-TP*Point) return (j);
		}
	return (-1);
}
//------------------------------------------------------------------ start
int start()
{ 
	int i, a, n, k, db, ds;
	//----
	for (i=Bars-1; i>=0; i--) { Buy[i]=0.0; Sell[i]=0.0; Buy1[i]=0.0; Sell1[i]=0.0; }
	i=Bars-1; n=0; db=0;
	while(i>=0)
	{
		a=Right(i, OP_BUY);
		ObjectCreate("Line"+i, OBJ_TREND, 0, Time[i], Buy[i], Time[a], Buy1[a]);
		if (a>0) 
		{ 
			Buy[i]= Open[i]; Buy1[a]=Open[i]+TP*Point; 
			ObjectCreate("BuyLine"+i, OBJ_TREND, 0, Time[i], Buy[i], Time[a], Buy1[a]);
			ObjectSet("BuyLine"+i, OBJPROP_COLOR, LimeGreen);
			ObjectSet("BuyLine"+i, OBJPROP_RAY, false);
			if (i==a) { i--; db++; } else { db+=(i-a); i=a; } n++; 
		}
		else i--;
	}
	i=Bars-1; k=0;  ds=0;
	while(i>=0)
	{
		a=Right(i, OP_SELL);
		if (a>0) 
		{ 
			Sell[i]= Open[i]; Sell1[a]=Open[i]-TP*Point; 
			ObjectCreate("SellLine"+i, OBJ_TREND, 0, Time[i], Sell[i], Time[a], Sell1[a]);
			ObjectSet("SellLine"+i, OBJPROP_COLOR, Red);
			ObjectSet("SellLine"+i, OBJPROP_RAY, false);
			if (i==a) { i--; ds++; } else { ds+=(i-a); i=a; } k++; 
		}
		else i--;
	}
	Comment("Buy=", n, " Sell=", k, "\n  () Buy=", Period()*db/n, "   Sell=", Period()*ds/k);
	
	return(0);
}
//+------------------------------------------------------------------+